Name:       iotcon
Summary:    Tizen IoT Connectivity
Version:    0.3.20
Release:    0
Group:      Network & Connectivity/Service
License:    Apache-2.0
Source0:    %{name}-%{version}.tar.gz
BuildRequires:  cmake
BuildRequires:  boost-devel
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(dlog)
BuildRequires:  pkgconfig(capi-base-common)
BuildRequires:  pkgconfig(capi-system-info)
BuildRequires:  pkgconfig(vconf)
BuildRequires:  pkgconfig(iotivity)
BuildRequires:  pkgconfig(uuid)
BuildRequires:  pkgconfig(cynara-client)
%if 0%{?gcov:1}
BuildRequires: lcov
%endif

Requires(post): /usr/bin/chgrp, /usr/bin/chmod, /usr/bin/chsmack


%description
Tizen IoT Connectivity Service & Library(Client) based on Iotivity


%package devel
Summary:    TizenIoT Connectivity(devel)
Group:      Network & Connectivity/Development
Requires:   %{name} = %{version}

%description devel
IoT Connectivity Manager development Kit


%package test
Summary:    Tizen IoT Connectivity(test)
Group:      Network & Connectivity/Testing
Requires:   %{name} = %{version}

%description test
Tizen IoT Connectivity Test Programs

%if 0%{?gcov:1}
%package gcov
Summary:  TizenIoT Connectivity library(gcov)
Group:    Connectivit/Testing
%description gcov
gcov objects for coverage test
%endif

%prep
%setup -q


%build
%if 0%{?gcov:1}
export CFLAGS+=" -fprofile-arcs -ftest-coverage"
export CXXFLAGS+=" -fprofile-arcs -ftest-coverage"
export FFLAGS+=" -fprofile-arcs -ftest-coverage"
export LDFLAGS+=" -lgcov"
%endif

%if "%{?profile}" == "tv"
%define PRODUCT_TV 1
%else
%define PRODUCT_TV 0
%endif

MAJORVER=`echo %{version} | awk 'BEGIN {FS="."}{print $1}'`
%cmake . -DMAJORVER=${MAJORVER} \
	-DFULLVER=%{version} \
	-DBIN_INSTALL_DIR:PATH=%{_bindir} \
	-DPRODUCT_TV=%{PRODUCT_TV} \
	-DBUILD_GCOV=%{?gcov:1}%{!?gcov:0}

%if 0%{?gcov:1}
make %{?jobs:-j%jobs}

mkdir -p gcov-obj
find . -name '*.gcno' -exec cp '{}' gcov-obj ';'
%endif

%install
rm -rf %{buildroot}
%make_install

%if 0%{?gcov:1}
mkdir -p %{buildroot}%{_datadir}/gcov/obj
install -m 0644 gcov-obj/* %{buildroot}%{_datadir}/gcov/obj
%endif

%post
/sbin/ldconfig

%postun
/sbin/ldconfig


%files
%manifest %{name}.manifest
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so.*
%license LICENSE.APLv2

%files devel
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/%{name}/*.h
%license LICENSE.APLv2

%files test
%manifest %{name}-test.manifest
%defattr(-,root,root,-)
%{_bindir}/iotcon-test-*
%license LICENSE.APLv2

%if 0%{?gcov:1}
%files gcov
%{_datadir}/gcov/obj/*
%endif
