/*
 * Copyright (c) 2015 - 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef __IOTCON_INTERNAL_ATTRIBUTES_H__
#define __IOTCON_INTERNAL_ATTRIBUTES_H__

#include "ic-value.h"
#include "ic-representation.h"

iotcon_attributes_h icl_attributes_ref(iotcon_attributes_h attributes);
int icl_attributes_create(iotcon_attributes_h *ret_attributes);
int icl_attributes_destroy(iotcon_attributes_h attributes);
int icl_attributes_add_int(iotcon_attributes_h attributes, const char *key, int val);
int icl_attributes_add_bool(iotcon_attributes_h attributes, const char *key, bool val);
int icl_attributes_add_double(iotcon_attributes_h attributes, const char *key, double val);
int icl_attributes_add_str(iotcon_attributes_h attributes, const char *key, char *val);
int icl_attributes_add_byte_str(iotcon_attributes_h attributes, const char *key, unsigned char *val, int len);
int icl_attributes_add_null(iotcon_attributes_h attributes, const char *key);
int icl_attributes_add_list(iotcon_attributes_h attributes, const char *key, iotcon_list_h list);
int icl_attributes_add_attributes(iotcon_attributes_h attributes, const char *key, iotcon_attributes_h val);
int icl_attributes_clone(iotcon_attributes_h attributes, iotcon_attributes_h *attributes_clone);

#endif /* __IOTCON_INTERNAL_ATTRIBUTES_H__ */
