/*
 * Copyright (c) 2015 - 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef __IOTCON_INTERNAL_RESOURCE_INTERFACES_H__
#define __IOTCON_INTERNAL_RESOURCE_INTERFACES_H__

#include <glib.h>
#include "iotcon-types.h"

struct icl_resource_ifaces {
	int ref_count;
	GList *iface_list;
};

iotcon_resource_interfaces_h icl_resource_interfaces_ref(
		iotcon_resource_interfaces_h res_ifaces);
int icl_resource_interfaces_create(iotcon_resource_interfaces_h *ret_ifaces);
int icl_resource_interfaces_destroy(iotcon_resource_interfaces_h ifaces);
int icl_resource_interfaces_add(iotcon_resource_interfaces_h ifaces,
		const char *iface);
int icl_resource_interfaces_remove(iotcon_resource_interfaces_h ifaces,
		const char *iface);
int icl_resource_interfaces_foreach(iotcon_resource_interfaces_h ifaces,
		iotcon_resource_interfaces_foreach_cb cb, void *user_data);
int icl_resource_interfaces_clone(iotcon_resource_interfaces_h src,
		iotcon_resource_interfaces_h *dest);

#endif /* __IOTCON_INTERNAL_RESOURCE_INTERFACES_H__ */
