/*
 * Copyright (c) 2015 - 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef __IOTCON_INTERNAL_RESOURCE_TYPES_H__
#define __IOTCON_INTERNAL_RESOURCE_TYPES_H__

#include <glib.h>
#include "iotcon-types.h"
#include "ic-query.h"

/**
 * @brief The maximum length which can be held in a resource type.
 *
 * @since_tizen 3.0
 */
#define ICL_RESOURCE_TYPE_LENGTH_MAX (ICL_QUERY_LENGTH_MAX - 3)


struct icl_resource_types {
	int ref_count;
	GList *type_list;
};

iotcon_resource_types_h icl_resource_types_ref(iotcon_resource_types_h res_types);
int icl_resource_types_create(iotcon_resource_types_h *ret_types);
int icl_resource_types_destroy(iotcon_resource_types_h types);
int icl_resource_types_add(iotcon_resource_types_h types, const char *type);
int icl_resource_types_remove(iotcon_resource_types_h types,
		const char *type);
int icl_resource_types_foreach(iotcon_resource_types_h types,
		iotcon_resource_types_foreach_cb cb, void *user_data);
int icl_resource_types_clone(iotcon_resource_types_h src,
		iotcon_resource_types_h *dest);

#endif /* __IOTCON_INTERNAL_RESOURCE_TYPES_H__ */
