/*
 * Copyright (c) 2015 - 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <stdlib.h>
#include <errno.h>
#include <glib.h>

#include "iotcon.h"
#include "ic.h"
#include "ic-utils.h"
#include "ic-resource.h"
#include "ic-representation.h"
#include "ic-options.h"
#include "ic-request.h"
#include "ic-response.h"

#include "ic-ioty.h"

int icl_response_destroy(iotcon_response_h resp)
{
	FN_CALL;
	RETV_IF(NULL == resp, IOTCON_ERROR_INVALID_PARAMETER);

	if (resp->repr)
		icl_representation_destroy(resp->repr);
	if (resp->header_options)
		icl_options_destroy(resp->header_options);
	free(resp);

	return IOTCON_ERROR_NONE;
}

