/*
 * Copyright (c) 2015 - 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef __IOTCON_INTERNAL_IC_H__
#define __IOTCON_INTERNAL_IC_H__

#include "iotcon.h"
#include "ic-common.h"
#include "ic-log.h"

#ifdef API
#undef API
#endif
#define API __attribute__((visibility("default")))

int icl_initialize(const char *file_path, bool is_pt);
int icl_deinitialize(void);
int icl_get_timeout(int *timeout_seconds);
int icl_set_timeout(int timeout_seconds);
int icl_polling_get_interval(int *interval);
int icl_polling_set_interval(int interval);
int icl_polling_invoke(void);

#endif /* __IOTCON_INTERNAL_IC_H__ */
